/*
 * Utils.h - Header file for the Utility Functions
 *
 * Written by: Craig A. Lindley
 * Version: 1.0
 * Last Update: 09/10/2014
 *
 * Copyright (c) 2014 Craig A. Lindley
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 * the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#ifndef UTILS_H
#define UTILS_H

// Logging levels for logging facility
#define LOG_ERROR   3
#define LOG_WARNING 2
#define LOG_INFO    1
#define LOG_MSG     0

// Utility Functions
void myprintf(char *fmt, ...);
void setLogLevel(int _logLevel);
void logger(int level, char *fmt, ...);

enum JS_DIRECTION {DIR_UP, DIR_DOWN, DIR_LEFT, DIR_RIGHT};

// Joystick and switch definitions
#define JOYSTICK_LEFT_STS     A1
#define JOYSTICK_LEFT_TTB     A2
#define JOYSTICK_LEFT_BUTTON  19
#define JOYSTICK_RIGHT_STS    A3
#define JOYSTICK_RIGHT_TTB    A4
#define JOYSTICK_RIGHT_BUTTON 20

boolean pollLeftJoystickButton();
void waitForLeftJoystickButton();

boolean pollRightJoystickButton();
void waitForRightJoystickButton();

boolean pollLeftJoystick();
enum JS_DIRECTION readLeftJoystick();

boolean pollRightJoystick();
enum JS_DIRECTION readRightJoystick();

#endif

